'use strict';

class TaxonomyChainMenu {
    constructor() {
        this.cache = [];
        this.reflection = null;
        this.chain_id = 'tcm_' + Math.random().toString(36).replace(/[^a-z]+/g, '').substr(0, 5);//unique identifier for js event operations
    }

}

(function ($) {

    let cache = [];
    let reflection = null;
    let chain_id = 'tcm_' + Math.random().toString(36).replace(/[^a-z]+/g, '').substr(0, 5);//unique identifier for js event operations

    window.addEventListener('load', function () {
        $.addEventListener('taxonomy-chain-menu', function (e) {
            //woocommerce products and wp posts table compatibility (PROTAS && TABLEON)
            if (e.detail.container) {

                let container = e.detail.container;

                if (container.dataset.chain_id) {
                    table_connector(e.detail, container.dataset.chain_id);
                }

                if (container.dataset.doFilter) {
                    if (!Boolean(e.detail.is_from_ready_chain)) {
                        let request_data = e.detail.request_data;
                        let term_id = parseInt(request_data.term_id);
                        let slug = null;

                        let selection = Array.from(container.querySelectorAll('select.taxonomy-chain-menu-taxonomy')).reverse().find(function (item) {
                            return parseInt(item.value) > 0;
                        });

                        if (selection) {
                            slug = selection.options[selection.selectedIndex].dataset.slug;
                        }

                        if (term_id === 0) {
                            if (container.querySelectorAll('select').length > 1) {
                                term_id = parseInt(selection.value);
                            }
                        }

                        switch (container.dataset.doFilter) {
                            case 'woof':
                                let ready_chain = '';

                                if (container.dataset.readyChain) {
                                    ready_chain = container.dataset.readyChain;
                                }

                                ready_chain = container.dataset.readyChain.replace(/(,0)$/, '');

                                woof_current_values['ready_chain'] = term_id + ',' + '0';


                                if (ready_chain.length > 0) {
                                    woof_current_values['ready_chain'] = '';
                                    container.querySelectorAll('select.taxonomy-chain-menu-taxonomy').forEach((item) => {
                                        woof_current_values['ready_chain'] += item.value + ',';
                                    });
                                }

                                woof_current_values['ready_chain'] = woof_current_values['ready_chain'].replace(/(,)$/, '');

                                if (slug) {
                                    woof_current_values[container.dataset.taxonomy] = slug;
                                } else {
                                    delete woof_current_values[container.dataset.taxonomy];
                                    delete woof_current_values['ready_chain'];
                                }

                                woof_submit_link(woof_get_submit_link());
                                break;

                            default:
                                $.dispatchEvent(new CustomEvent('taxonomy-chain-menu-do-filter', {detail: {term_id, slug, container, chain_id}}));
                                break;
                        }

                    } else {
                        $.querySelector('.woof_products_top_panel').remove();
                    }

                }
            }
        });

        //+++

        $.body.addEventListener('change', function (e) {
            if (e.target.tagName.toLowerCase() === 'select') {
                let select = e.target;

                if (e.target.classList.contains('taxonomy-chain-menu-taxonomy')) {
                    trigger_taxonomy_select(select);
                }

                if (e.target.classList.contains('taxonomy-chain-menu-post')) {
                    trigger_post_select(select);
                }
            }

            return true;
        });

        //+++
        //for ready_chain, selectron23 and etc...
        [].forEach.call($.querySelectorAll('div.taxonomy-chain-menu'), function (container) {

            _set_select_width(container);
            _set_selectron23_height(container);

            //+++

            if (container.dataset.readyChain) {
                let data = container.dataset.readyChain.split(',');
                let last = data[data.length - 1];

                if (last !== '0') {
                    let sels = container.querySelectorAll('select');
                    if (container.dataset.watchView !== 'none') {
                        if (container.dataset.watchView === 'terms') {
                            if (sels[sels.length - 1].value > 0) {
                                let l = sels[sels.length - 1].options[sels[sels.length - 1].selectedIndex].dataset.link;
                                create_button(container, l, 'taxonomy-chain-menu-btn');
                            }
                        } else {
                            create_button(container, (sels[sels.length - 1]).value);
                        }
                    }
                }

                //+++
                let val = 0;
                container.querySelectorAll('select.taxonomy-chain-menu-taxonomy').forEach(function (item, index) {
                    if (item.value > 0) {
                        val = item.value;
                    }
                });

                if (val) {
                    setTimeout(() => {
                        let node = null;
                        let is_from_ready_chain = 1;
                        cast_event(prepare_request_data(container, val, 'taxonomy'), container, node, is_from_ready_chain);
                    }, 333);
                }
            }

            //+++
            //for outside connection
            Array.from(container.querySelectorAll('select.taxonomy-chain-menu-taxonomy')).forEach(function (select) {
                append_select_changed_event(select);
            });

            //+++

            if (container.dataset.select_wrapper === 'selectron23') {
                reflection = new TCM_Reflector(container, chain_id);
            }

            return true;
        });
    });

    function _set_selectron23_height(container) {
        let selectron23_height = [];
        if (container.dataset.selectron23_max_open_height) {
            selectron23_height = container.dataset.selectron23_max_open_height.split('|');
        }

        if (selectron23_height.length > 0) {
            container.querySelectorAll('select.taxonomy-chain-menu-taxonomy').forEach(function (item, index) {

                if (typeof selectron23_height[index] !== 'undefined') {
                    item.setAttribute('data-selectron23-open-height', selectron23_height[index]);
                } else {
                    item.setAttribute('data-selectron23-open-height', selectron23_height[selectron23_height.length - 1]);
                }

            });
        }
    }

    function _set_select_width(container) {
        let select_width = [];
        if (container.dataset.selectWidth) {
            select_width = container.dataset.selectWidth.split('|');
        }

        if (select_width.length > 0) {
            container.querySelectorAll('select.taxonomy-chain-menu-taxonomy').forEach(function (item, index) {

                if (typeof select_width[index] !== 'undefined') {
                    item.style.maxWidth = item.style.width = select_width[index];
                } else {
                    item.style.maxWidth = item.style.width = select_width[select_width.length - 1];
                }

            });
        }
    }

    function append_select_changed_event(select) {
        if (select.tagName.toLowerCase() === 'select') {
            select.addEventListener('taxonomy-chain-menu-select-changed', function (e) {

                if (e.detail.chain_id === chain_id) {
                    console.log(chain_id);
                    this.value = e.detail.value;
                    if (this.options.length > 0) {
                        for (let i = 0; i < this.options.length; i++)
                        {
                            if (this.options[i].value.toString() == this.value.toString()) {
                                this.selectedIndex = i;
                                this.options[i].setAttribute('selected', true);
                            } else {
                                this.options[i].removeAttribute('selected');
                            }
                        }
                    }

                    if (this.classList.contains('taxonomy-chain-menu-post')) {
                        trigger_post_select(this);
                    } else {
                        trigger_taxonomy_select(this);
                    }
                }

            });
        }
    }

    function trigger_taxonomy_select(select) {
        let container = select.parentNode;
        let term_id = parseInt(select.value);
        remove_siblings(select);

        if (reflection) {
            reflection.clone();
        }

        if (cache[term_id]) {
            if (cache[term_id]['node']) {
                if (cache[term_id]['node'].options.length > 0) {
                    for (let i = 0; i < cache[term_id]['node'].options.length; i++)
                    {
                        cache[term_id]['node'].options[i].removeAttribute('selected');//!!
                    }
                }
                container.appendChild(cache[term_id]['node']);
                container.querySelectorAll('select')[container.querySelectorAll('select').length - 1].value = 0;
            } else {
                create_button(container, cache[term_id]['text'], 'taxonomy-chain-menu-btn');
            }

            cast_event(cache[term_id]['request_data'], cache[term_id]['container'], cache[term_id]['node']);

            if (reflection) {
                reflection.clone();
            }
        } else {

            let request_data = prepare_request_data(container, term_id, select.dataset.type);

            //+++

            let do_fetch = true;

            if (container.dataset.watchView === 'terms') {
                if (parseInt(select.options[select.selectedIndex].dataset.childCount) === 0) {
                    do_fetch = false;
                }
            }

            if (do_fetch) {
                if (term_id > 0) {
                    loader(container);

                    fetch(taxonomy_chain_menu.ajax_url, {
                        method: 'POST',
                        credentials: 'same-origin',
                        body: (function (data) {
                            const formData = new FormData();

                            Object.keys(data).forEach(function (k) {
                                formData.append(k, data[k]);
                            });

                            return formData;
                        })(request_data)
                    }).then(response => response.text()).then(text => {

                        const doc = (new DOMParser()).parseFromString(text, 'text/html');
                        let node = doc.body.querySelectorAll('*')[0];

                        loader(container, false);

                        if (node) {
                            container.appendChild(node);

                            _set_select_width(container);
                            _set_selectron23_height(container);

                            append_select_changed_event(node);
                            cache[term_id] = {request_data, container, node};
                        } else {
                            if (container.dataset.watchView !== 'none') {
                                if (container.dataset.watchView === 'posts') {
                                    container.appendChild(node);
                                    cache[term_id] = {request_data, container, node};
                                } else {
                                    create_button(container, text, 'taxonomy-chain-menu-btn');
                                    cache[term_id] = {request_data, container, text};
                                }
                            }
                        }


                        cast_event(request_data, container, node);

                        if (reflection) {
                            reflection.clone();
                        }

                    }).catch((err) => {
                        console.log(err);
                    });
                } else {
                    cast_event(request_data, container);
                }
            } else {
                create_button(container, select.options[select.selectedIndex].dataset.link, 'taxonomy-chain-menu-btn');
                if (reflection) {
                    reflection.clone();
                }
                cast_event(request_data, container);
            }
        }


    }

    function trigger_post_select(select) {
        let container = select.parentNode;
        remove_siblings(select);
        if (parseInt(select.value) !== 0) {
            create_button(container, select.value);
        }

        if (reflection) {
            reflection.clone();
        }
    }

    function cast_event(request_data, container, node = null, is_from_ready_chain = null) {
        $.dispatchEvent(new CustomEvent('taxonomy-chain-menu', {detail: {request_data, container, node, is_from_ready_chain, chain_id}}));
    }

    function prepare_request_data(container, term_id, type) {
        let request_data = {
            action: 'taxonomy_chain_menu',
            count_of_selects: container.querySelectorAll('select').length,
            term_id,
            type
        };

        let dataset = Object.assign({}, container.dataset);

        if (Object.keys(dataset).length > 0) {
            Object.keys(dataset).forEach(function (key) {
                //keys normalizing from dataset
                request_data[key.replace(/([A-Z])/, '_$1').toLowerCase()] = dataset[key];
            });
        }

        return request_data;
    }

    function create_button(container, href, class_name = 'taxonomy-chain-menu-btn') {
        let a = $.createElement('a');
        a.className = class_name;
        a.setAttribute('href', href);
        a.setAttribute('target', container.dataset.target);
        a.innerText = container.dataset.buttonTitle;
        container.appendChild(a);
    }

    function remove_siblings(elem) {
        let siblings = (function (elem) {
            let matched = [];

            while (elem = elem.nextSibling) {
                if (elem.nodeType === 1) {
                    matched.push(elem);
                }
            }

            return matched;
        })(elem);

        if (siblings.length > 0) {
            siblings.forEach(function (item) {
                item.remove();
            });
        }
    }

    function loader(container, create = true) {
        if (create) {
            let img = $.createElement('img');
            img.className = 'taxonomy-chain-menu-loader';
            img.setAttribute('src', taxonomy_chain_menu.loader);
            img.setAttribute('loading', 'lazy');
            container.appendChild(img);
            if (reflection) {
                reflection.append(img.cloneNode(true));
            }
            return true;
        }

        container.querySelector('img.taxonomy-chain-menu-loader').remove();
    }

    //***

    //connector for TABLEON && PROTAS, uses in event 'taxonomy-chain-menu' only
    function table_connector(data, chain_id) {
        if (typeof DataTable23 !== 'undefined') {
            if (data.request_data.chain_id === chain_id) {
                let table = null;
                let request_data = data.request_data;
                let term_id = parseInt(request_data.term_id);

                if (term_id === 0) {
                    //if to deselect any select in the chain
                    if (data.container.querySelectorAll('select').length > 1) {
                        Array.from(data.container.querySelectorAll('select.taxonomy-chain-menu-taxonomy')).reverse().forEach(function (item) {
                            if (item.value > 0 && !term_id) {
                                term_id = parseInt(item.value);
                                return true;
                            }
                        });
                    }
                }

                if (request_data.connect_table) {
                    if (table = DataTable23.tables[request_data.connect_table]) {

                        if (term_id > 0) {
                            table.request_data.filter_data = {
                                [request_data.taxonomy]: term_id
                            };
                        } else {
                            delete table.request_data.filter_data[request_data.taxonomy];
                        }

                        table.redraw_table();
                    }
                }
            }
        }
    }

}
)(document);
